unit BIniReader;

// Code by Schmackbolzen

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;
function LoadBiniFile(const path:string):TStrings;

implementation
  uses StringTable;

function LoadBiniFile(const path:string):TStrings;
var FileStream:TFileStream;
    bufChar:array [0..3] of char;
    j,k:Integer;
    bufInt16:Word;
    bufByte,ValueCount:byte;
    StringTable:TStringTable;
    StringTableOffset,bufDWord:cardinal;
    CurrentLine:string;
begin
 result:=TStringList.Create;
 FileStream:=TFileStream.Create(path,fmOpenRead);
 FileStream.ReadBuffer(bufChar,4);
 if bufChar = 'BINI' then
  begin
   FileStream.Seek(4,fsFromCurrent); // Version number is of no interest
   FileStream.ReadBuffer(StringTableOffset,4);
   StringTable.LoadStringTable(FileStream,StringTableOffset);
   while FileStream.Position < StringTableOffset do
   begin
   FileStream.ReadBuffer(bufInt16,2);
   result.Add('['+ StringTable.GetStringAtOffset(bufInt16)+']');
   //form1.Memo1.Lines.add('['+ StringTable.GetStringAtOffset(bufInt16)+']');
   FileStream.ReadBuffer(bufInt16,2);
   for j := 0 to bufInt16-1 do
    begin
     FileStream.ReadBuffer(bufInt16,2);
     //form1.Memo1.Lines.add('Offset wanted: '+inttostr(bufInt16));
     CurrentLine:=StringTable.GetStringAtOffset(bufInt16)+' = ';
     FileStream.ReadBuffer(ValueCount,1);
      for k := 0 to ValueCount-1 do
       begin
        FileStream.ReadBuffer(bufByte,1);
        FileStream.ReadBuffer(bufDWord,4);
        case bufByte of
         1:CurrentLine+=IntToStr(Integer(bufDWord));
         2:CurrentLine+=FloatToStr(Single((@bufDWord)^));  // We love pointers! (Seriously, just a hack to get direct bytewise access)
         3:CurrentLine+=StringTable.GetStringAtOffset(bufDWord);
        end;
        if k < ValueCount-1 then
         CurrentLine+=', ';
       end;
      result.Add(CurrentLine);
    end;
   end;
   FileStream.Free;
  end
 else
  begin
   FileStream.Free;
   result.LoadFromFile(path);
  end;

end;

end.

