unit GenericDynArray;
//Optimized dynamic array memory handling (faster resizing)
// Code by Schmackbolzen

{$mode objfpc}{$H+}{$inline on}

interface

uses
  Classes, SysUtils;

type generic TGenericDynArray<_T> = object
        private
        type PointAt = ^_T;
        var RealLength,SimulatedLength:cardinal;
        dynarray:array of _T;
        public
        procedure init;inline;
        procedure resize(const newLength:cardinal);inline;
        function high:integer; inline;
        function length:cardinal; inline;
        function AppendOne:cardinal;inline;
        function GetAtIndex(const index:cardinal):PointAt; inline;
        function GetLastEntry:PointAt; inline;
        procedure FreeUnused; inline;
       end;

implementation

function TGenericDynArray.AppendOne:cardinal; inline;
begin
 result:=SimulatedLength;
 resize(SimulatedLength+1);
end;

procedure TGenericDynArray.FreeUnused; inline;
begin
 SetLength(dynarray,SimulatedLength);
 RealLength:=SimulatedLength;
end;

function TGenericDynArray.length:cardinal; inline;
begin
 result:=SimulatedLength;
end;

function TGenericDynArray.GetLastEntry:PointAt; inline;
begin
 result:=@dynarray[high];
end;

function TGenericDynArray.GetAtIndex(const index:cardinal):PointAt; inline;
begin
 result:=@dynarray[index];
end;

function TGenericDynArray.high:integer; inline;
begin
 result:=SimulatedLength-1
end;

procedure TGenericDynArray.init;inline;
begin
 RealLength:=0;
 setlength(dynarray,RealLength);
 SimulatedLength:=0;
end;

procedure TGenericDynArray.resize(const newLength:cardinal);inline;
var oldLength:cardinal;
begin
 oldLength:=RealLength;
  SimulatedLength:=newLength;
 if RealLength = 0 then
   RealLength:=newLength
 else if RealLength*2 < newlength then
    RealLength:=newlength
 else if RealLength < newlength then
     RealLength:=RealLength*2;

 if oldLength<>RealLength then
    setlength(dynarray,RealLength);
end;

end.

